<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
	<title>SimpleTAL API: simpleTAL Module</title>
	<link href="../style/site.css" type="text/css" rel="stylesheet">
</head>
<body>
<h1>SimpleTAL API: simpleTAL Module</h1>
  <p id="subject">Documentation on how to use the simpleTAL Module.</p>
  <div><h2>simpleTAL</h2>
<p>Two helper functions are provided for convenience, one for compiling HTML templates, and one for compiling XML templates.&nbsp; If an error is encountered during compilation (for example mismatched TAL tags or bad syntax) an TemplateParseException will be thrown.</p>
<h3>compileHTMLTemplate (template, minimizeBooleanAtts=0)</h3>
<p>Compiles the passed in HTML template into an instance of the 'Template' class.&nbsp; The template object should be either a string containing the template, or a file-like object that returns strings.&nbsp; The minimizeBooleanAtts flag controls whether HTML boolean attributes (e.g. &lt;img ismap&gt;) should be written out in minimized form.&nbsp; See below for details of how to use the Template class.</p>
<h3>compileXMLTemplate (template)</h3>
<p>Compiles the passed in XML template into an instance of the 'Template' class.&nbsp; The template object should be a string or bytes object containing the template, or a file-like object that returns strings or bytes.&nbsp; The XML template must be a well formed XML document.&nbsp; See below for details of how to use the Template class.</p>
<h3>Template Instances</h3>
<p>The compiled templates contain all of the logic required to be able to expand themselves for a given context.&nbsp; They can be kept around and reused as often as required, there is no need to re-compile them unless the underlying template changes.&nbsp; They have one method of interest as part of the external API:</p>
<pre>
<code>
def expand (self, context, outputFile [,outputEncoding='utf-8'] [,docType=None] [,suppressXMLDeclaration=False])
</code>
</pre>
<p>This method will expand the template, using the simpleTALES.Context object provided, and write the output into the given file-like object.&nbsp; If the outputFile is an instance of io.TextIOBase or codecs.StreamWriter then strings are written to the file, otherwise the output is encoded in outputEncoding.&nbsp; XML Templates will output the appropriate XML declaration for the outputEncoding, independently of whether strings or bytes are written out.&nbsp; </p>
<p>The docType and suppressXMLDeclaration arguments only apply to XML Templates.&nbsp; </p>
<p>Python's support for XML does not currently extend to the LexicalHandler API, which is required for an application to be able to read an XML documents DOCTYPE.&nbsp; The doctype must be passed as a named variable to the expand method.</p>
<p>For example to produce a valid strict XHTML document use:</p>
<pre>
<code>
template.expand (context, outputFile, docType='&lt;!DOCTYPE html&nbsp; PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"&gt;')
</code>
</pre>
<p>If the suppressXMLDeclaration is set to true then the XML Declaration will not be included in the output (required for XHTML in IE6).</p>
<p><a href="api.html">Back to SimpleTAL API</a></p>
</div>
	  
  <p id="version">PubTal Version </p>
  <div id="footer">
  <p>File: api-simpletal.txt</p>
  <p>Last modified: Sat, 15 Aug 2009 12:30:36 BST</p>
  <p>Copyright 2011 Colin Stewart</p>
  <p title="PubTal is a template driven web site publisher.">Made with <a href="http://www.owlfish.com/software/PubTal/">PubTal</a> 3.5</p>
  </div>
</body>
